
local tablet = AceLibrary("Tablet-2.0")
local dewdrop = AceLibrary("Dewdrop-2.0")
local metro = AceLibrary("Metrognome-2.0")
local enabledmodule, usetime

tekSupport = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceModuleCore-2.0")
tekSupport:RegisterDB("tekSupportDB", "tekSupportDBPC")
tekSupport.hasNoText = true
tekSupport.hasIcon  = "Interface\\Icons\\Spell_ChargePositive"


function tekSupport:OnInitialize()
	for name,module in self:IterateModules() do self:ToggleModuleActive(module, false) end
	metro:Register(self.name, self.Update, 1, self)
end


function tekSupport:OnEnable()
	metro:Start(self.name)
end


function tekSupport:OnDisable()
	metro:Stop(self.name)
end


function tekSupport:OnTooltipUpdate()
	if enabledmodule then
		tablet:AddCategory("text", tostring(enabledmodule) or "???", "showWithoutChildren", true, "justify", "CENTER")
		if enabledmodule.OnTooltipUpdate then enabledmodule:OnTooltipUpdate(usetime)
		elseif usetime then enabledmodule:OnTooltipUpdateTime()
		else enabledmodule:OnTooltipUpdateMem() end
	end
end


function tekSupport:OnMenuRequest()
	dewdrop:AddLine()
	dewdrop:AddLine("text", "Modules:", "isTitle", true)
	for name,module in self:IterateModules() do
		dewdrop:AddLine("text", name, "isRadio", true, "checked", module == enabledmodule, "func", self.SwitchModule, "arg1", self, "arg2", module)
		self:ToggleModuleActive(module, false)
	end

	dewdrop:AddLine()
	dewdrop:AddLine("text", "Sort By:", "isTitle", true)
	dewdrop:AddLine("text", "Time", "isRadio", true, "checked", usetime, "func", self.OnClick)
	dewdrop:AddLine("text", "Memory", "isRadio", true, "checked", not usetime, "func", self.OnClick)
	dewdrop:AddLine()
end


function tekSupport:SwitchModule(module)
	if enabledmodule then self:ToggleModuleActive(enabledmodule, false) end

	enabledmodule = module
	self:ToggleModuleActive(enabledmodule, true)
end


function tekSupport:OnClick()
	usetime = not usetime
end
