
local metro1 = Metrognome and Metrognome:GetInstance("1")
local metro2 = AceLibrary("Metrognome-2.0")
local tablet = AceLibrary("Tablet-2.0")

local maxttitems, sortedframes, hooks, insort, frameshooked = 50, {}, {}, {}
local blacklist = {
	["Metrognome-2.0 Frame"] = true,
	["Metrognome Frame"] = true,
	["AceEvent20Frame"] = true,
}


tekSupport_OnUpdate = tekSupport:NewModule("OnUpdate Handlers")


local function callandsave(f, mem, time, ...)
	mem, time = collectgarbage("count") - mem, GetTime() - time

	if mem >= 0 then
		f.time = f.time + time
		f.mem = f.mem + mem
		f.count = f.count + 1
	end

	return ...
end


local function HookedFrame(frame, elapsed)
	local mem, time, f = collectgarbage("count"), GetTime(), hooks[frame]
	if not f then return end
	callandsave(f, mem, time, f.script(frame, elapsed))
end


function tekSupport_OnUpdate:OnEnable()
	if frameshooked then return end

	local f = EnumerateFrames()
	while f do
		local script = f and f:GetScript("OnUpdate")
		if script then
			local name = f.GetName and f:GetName() or f.name or tostring(f)
			if not blacklist[name] then
				hooks[f] = {script = script, name = name, count = 0, time = 0, mem = 0}
				f:SetScript("OnUpdate", HookedFrame)
				table.insert(sortedframes, hooks[f])
			end
		end
		f = EnumerateFrames(f)
	end
	frameshooked = true
end


local function SortMem(a, b)
	if not a.count or a.count == 0 then return end
	if not b.count or b.count == 0 then return true end
	local r1 = a.rate and a.rate > 0 and a.rate or GetFramerate()
	local r2 = b.rate and b.rate > 0 and b.rate or GetFramerate()
	local dif = ((a.mem or 0)/(r1*a.count)) - ((b.mem or 0)/(r2*b.count))
	if dif ~= 0 then return dif > 0 end
	return a.name < b.name
end


local function SortTime(a, b)
	if not a.count or a.count == 0 then return end
	if not b.count or b.count == 0 then return true end
	local r1 = a.rate and a.rate > 0 and a.rate or 1/GetFramerate()
	local r2 = b.rate and b.rate > 0 and b.rate or 1/GetFramerate()
	local dif = ((a.time or 0)/(r1*a.count)) - ((b.time or 0)/(r2*b.count))
	if dif ~= 0 then return dif > 0 end
	return a.name < b.name
end


function tekSupport_OnUpdate:OnTooltipUpdate(usetime)
	if metro1 then
		for _,v in pairs(metro1.var.handlers) do
			if not insort[v] then
				table.insert(sortedframes, v)
				insort[v] = true
			end
		end
	end

	if metro2 then
		for _,v in pairs(metro2.var.handlers) do
			if not insort[v] then
				table.insert(sortedframes, v)
				insort[v] = true
			end
		end
	end

	table.sort(sortedframes, usetime and SortTime or SortMem)

	local cat = tablet:AddCategory("columns", 6, "text", "Timer", "text2", "Count",
		"text3", "Mem", "text4", (not usetime and "|cffff0000" or "") .. "Mem/sec",
		"text5", "Time", "text6", (usetime and "|cffff0000" or "") .. "Time/sec",
		"child_justify3", "RIGHT", "child_justify4", "RIGHT", "child_justify5", "RIGHT")

	local frate, i = GetFramerate(), 1
	for _,v in ipairs(sortedframes) do
		local r = v.rate and v.rate > 0 and v.rate or 1/frate
		if i < maxttitems and v.count and (((v.mem or 0)/(r*v.count)) >= 1 or ((v.time or 0)/(r*v.count)*1000) >= 1.0) then
			i = i + 1
			cat:AddLine("text", v.name, "text2", v.count,
				"text3", string.format("%d KiB", (v.mem or 0)),
				"text4", string.format("%.1f KiB", v.mem/(r*v.count)),
				"text5", string.format("%d ms", v.time*1000),
				"text6", string.format("%.1f ms", v.time/((v.count or 1)*r)*1000))
		end
	end
end




